-- TurretHop 1.1 by AbortRetryFail

local timer = Timer()

local function GetTurret(turret)
	local turretnames = GetTurretNamesByStationType(GetStationType())
	local sti = GetStationTurretInfo(turret)
	sectorprint("Switching to turret: "..tostring(turret)..": "..tostring(turretnames[sti.itemid]))
	PurchaseMerchandiseItem(sti.itemid)
end

function TurretHop(_, args)
	local numturrets = GetNumStationTurrets()
	local turret = tonumber(args[1])
	if numturrets and turret and turret >= 1 and turret <= numturrets then
		if HUD.hudtype == "turret" then
			gkinterface.GKProcessCommand("Activate")
			timer:SetTimeout(256, GetTurret(turret)) -- Sometimes /activate takes a bit too long to switch out of the turret.
		else
			GetTurret(turret)
		end
	end
end

RegisterUserCommand("turrethop", TurretHop)
